<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <title>Sample Project | NESAC</title>
    {% load static %}
    <!--Add mapbox.js -->
    <script src='https://api.tiles.mapbox.com/mapbox.js/v1.6.2/mapbox.js'></script>
    <link href='https://api.tiles.mapbox.com/mapbox.js/v1.6.2/mapbox.css' rel='stylesheet' />

    <!--Add draw plugin -->
    <link rel='stylesheet' href='//api.tiles.mapbox.com/mapbox.js/plugins/leaflet-draw/v0.2.2/leaflet.draw.css' />
    <script src='//api.tiles.mapbox.com/mapbox.js/plugins/leaflet-draw/v0.2.2/leaflet.draw.js'></script>
    
    <!-- <link rel="icon" href="{% static 'img/mdb-favicon.ico' %}" type="image/x-icon"> -->
    <link rel="icon" href="{% static 'img/nesac-logo-retina.png' %}" type="image/x-icon">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.11.2/css/all.css">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700&display=swap">
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">
    <link rel="stylesheet" href="{% static 'css/mdb.min.css' %}">
    <!-- <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"> -->

    <!-- <link rel="stylesheet" href="{% static 'css/my.css' %}"> -->
    <link rel="stulesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.5.2/css/bootstrap.css">
    <link rel="stulesheet" href="https://cdn.datatables.net/1.10.22/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="{% static 'css/style.css' %}">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>

    <script src="https://code.highcharts.com/highcharts.js"></script>
    <script src="https://code.highcharts.com/modules/series-label.js"></script>
    <script src="https://code.highcharts.com/modules/exporting.js"></script>
    <script src="https://code.highcharts.com/modules/export-data.js"></script>
    <script src="https://code.highcharts.com/modules/accessibility.js"></script>
    <script src='https://kit.fontawesome.com/a076d05399.js'></script>

    <link href='https://cdnjs.cloudflare.com/ajax/libs/leaflet/1.3.1/leaflet.css' rel='stylesheet' type='text/css'>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/leaflet/1.3.1/leaflet.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/leaflet.draw/1.0.4/leaflet.draw.css"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/leaflet.draw/1.0.4/leaflet.draw.js"></script>


    <script src="https://code.jquery.com/jquery-3.5.1.js"></script>
    <script src="https://cdn.datatables.net/1.10.22/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.22/js/dataTables.bootstrap4.min.js"></script>


    <script type="text/javascript" src="{% static 'js/jquery.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'js/popper.min.js' %}"></script>
    <!-- Bootstrap core JavaScript -->
    <script type="text/javascript" src="{% static 'js/bootstrap.min.js' %}"></script>
    <!-- MDB core JavaScript -->
    <script type="text/javascript" src="{% static 'js/mdb.min.js' %}"></script>
    <!-- Your custom scripts (optional) -->
    <script type="text/javascript"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
</head>

<body>
<header id="header">
</header>
<div class=" container-fluid">
    <div class="row h-100">
        <div class="col-md-3">
            <table id="myTable">
                <tbody>
                <tr>
                    <td style="color:blue; font-family:Times New Roman;">
                        <h5>&nbsp;Source &nbsp;</h5>
                    </td>
                    <td style="color:blue; font-family:Times New Roman;" colspan="1">
                        <select id="image_source"
                                style="border-radius:10px; outline: none !important; width:70%">
                            <option value='Sentinel-2'>Sentinel-2</option>
                        </select>
                    </td>
                </tr>

                <tr>
                    <td style="color:blue; font-family:Times New Roman;">
                        <h5>&nbsp;FileList&nbsp;</h5>
                    </td>
                    <td colspan="1">
                        <select id="FileUnder" style="border-radius:10px;outline: none !important; width:70%;"
                                onchange="view_tiff()">
                            <option value="S2A_MSIL1C_20201030T041921_N0209_R090_T46RDQ_20201030T061133.tif">
                                S2A_MSIL1C_20201030T041921_N0209_R090_T46RDQ_20201030T061133
                            </option>
                            <option value="S2A_MSIL1C_20201112T043031_N0209_R133_T46RDQ_20201112T054534.tif">
                                S2A_MSIL1C_20201112T043031_N0209_R133_T46RDQ_20201112T054534
                            </option>
                        </select>
                    </td>
                </tr>

                <tr>
                    <td style="color:blue; font-family:Times New Roman;">
                        <h5>&nbsp;Band&nbsp;</h5>
                    </td>
                    <td colspan="1">
                        <select id='band1'>
                            <option value='1' selected>1</option>
                            <!-- <option value='2' selected>2</option> -->
                            <option value='2'>2</option>
                            <option value='3'>3</option>
                            <option value='4'>4</option>
                            <option value='5'>5</option>
                            <option value='6'>6</option>
                            <option value='7'>7</option>
                            <option value='8'>8</option>
                            <option value='9'>9</option>
                            <option value='10'>10</option>
                            <option value='11'>11</option>
                            <option value='12'>12</option>
                            <option value='13'>13</option>
                            <!-- <option value='4'>4</option> -->
                        </select>
                        <select id='band2'>
                            <option value='1'>1</option>
                            <option value='2' selected>2</option>
                            <option value='3'>3</option>
                            <option value='4'>4</option>
                            <option value='5'>5</option>
                            <option value='6'>6</option>
                            <option value='7'>7</option>
                            <option value='8'>8</option>
                            <option value='9'>9</option>
                            <option value='10'>10</option>
                            <option value='11'>11</option>
                            <option value='12'>12</option>
                            <option value='13'>13</option>
                            <!-- <option value='4'>4</option> -->
                        </select>
                        <select id='band3'>
                            <option value='1'>1</option>
                            <option value='2'>2</option>
                            <option value='3' selected>3</option>
                            <option value='4'>4</option>
                            <option value='5'>5</option>
                            <option value='6'>6</option>
                            <option value='7'>7</option>
                            <option value='8'>8</option>
                            <option value='9'>9</option>
                            <option value='10'>10</option>
                            <option value='11'>11</option>
                            <option value='12'>12</option>
                            <option value='13'>13</option>
                            <!-- <option value='4' selected>4</option> -->
                        </select>
                    </td>
                </tr>

                <tr>
                    <td style="color:blue; font-family:Times New Roman;">
                        <h5>&nbsp;Input&nbsp;</h5>
                    </td>
                    <td>
                        <button type="button" id='viewInput' class="btn btn-primary btn-rounded btn-block btn-sm"
                                onclick="view_tiff()">View
                        </button>
                    </td>
                    <!--<td>
                        <button type="button" id='removeInput' class="btn btn-primary btn-rounded btn-block btn-sm"
                                onclick="remove_input_layer()">Remove
                        </button>
                    </td>-->

                </tr>
                <tr>
                    <td>
                        <a href='#' id='export' onclick="exportGeo()"class="btn btn-primary btn-rounded btn-block btn-sm">
                            Export Features
                        </a>
                    </td>
                    <td>
                        <a href='#' id='add' onclick="add()"class="btn btn-primary btn-rounded btn-block btn-sm">
                            Add to Model output
                        </a>
                    </td>
                    <td>
                        <a href='#' id='add' onclick="subtract()"class="btn btn-primary btn-rounded btn-block btn-sm">
                            Subtract from Model output
                        </a>
                    </td>
                </tr>
                <tr>
                    <td>
                        <a href="#" id='add-down' class="btn btn-primary btn-rounded btn-block btn-sm">
                            Download Added
                        </a>
                    </td>
                    <td>
                        <a href='#' id='sub-down' class="btn btn-primary btn-rounded btn-block btn-sm">
                            Download subtracted
                        </a>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>
        <div id="map" class="col-md-9 " style="height:100vh">
        </div>
    </div>
</div>

<script>

    $(function () {
        $("#one").change(function (e) {
            $("#two").empty();

            var options =
            $("#one option").filter(function(e){
                return $(this).attr("value") > $("#one option:selected").val();
            }).clone();

            $("#two").append(options);
        });
    });

    var patch_folder;
    var bas_url = 'http://localhost:8000/'
    var orginal_image
    var class_image
    var classified_image;
    var osm = L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
		attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
		minZoom: 2,
		maxZoom: 18
	});

    var merged_file_id
    var sub_file_id

	//  .. CartoDB Positron
	var cartodb = L.tileLayer('http://{s}.basemaps.cartocdn.com/light_all/{z}/{x}/{y}.png', {
		attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors, &copy; <a href="http://cartodb.com/attributions">CartoDB</a>',
		minZoom: 2,
		maxZoom: 18
	});
	//  .. OSM Toner
	var toner = L.tileLayer('http://{s}.tile.stamen.com/toner/{z}/{x}/{y}.png', {
		attribution: 'Map tiles by <a href="http://stamen.com">Stamen Design</a>, under <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a>. Data by <a href="http://openstreetmap.org">OpenStreetMap</a>, under <a href="http://www.openstreetmap.org/copyright">ODbL</a>.',
		minZoom: 2,
		maxZoom: 18
	});
	//  .. White background
	var white = L.tileLayer("data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAQAAAAEAAQMAAABmvDolAAAAA1BMVEX///+nxBvIAAAAH0lEQVQYGe3BAQ0AAADCIPunfg43YAAAAAAAAAAA5wIhAAAB9aK9BAAAAABJRU5ErkJggg==", {
		minZoom: 2,
		maxZoom: 18
    });
    googleTerrain = L.tileLayer('http://{s}.google.com/vt/lyrs=p&x={x}&y={y}&z={z}',{
    maxZoom: 20,
    subdomains:['mt0','mt1','mt2','mt3']
    });
    googleSat = L.tileLayer('http://{s}.google.com/vt/lyrs=s&x={x}&y={y}&z={z}',{
    maxZoom: 20,
    subdomains:['mt0','mt1','mt2','mt3']
    });
    var map = L.map('map', {
		center: [25.00030431762018, 94.53015726225982],
		zoom: 6,
		minZoom: 2,
		maxZoom: 18,
		layers: [cartodb],
		zoomControl: true
    });

    var basemaps = {
		"CartoDB Positron": cartodb,
		"OpenStreetMap": osm,
		"Stamen Toner": toner,
        "Without background": white,
        "Google_MAP": googleTerrain,
        "googleSat": googleSat
	}

    // // L.control.layers(basemaps).addTo(map);
    layerControl = L.control.layers(basemaps).addTo(map);

    var drawnItems = new L.FeatureGroup();
    var drawControl = new L.Control.Draw({
          draw: {
          rectangle: true,
          circle: false,
          polyline: false,
          marker: false,
          circlemarker: false,
          polygon: true
         },
            edit: {
                featureGroup: drawnItems,
                remove: true
            }
        }).addTo(map);
    map.on('draw:created', function(e) {
            // Each time a feaute is created, it's added to the over arching feature group
            // console.log(e.layer._bounds);
            map.fitBounds(e.layer._bounds);
            drawnItems.addLayer(e.layer);
            map.addLayer(e.layer)
            console.log(drawnItems.toGeoJSON());
    });

    map.addControl(drawControl);

    var exportGeo = function(e) {
        // Extract GeoJson from featureGroup
        var data = drawnItems.toGeoJSON();
        console.log(data);
        // Stringify the GeoJson
        var convertedData = 'text/json;charset=utf-8,' + encodeURIComponent(JSON.stringify(data));

        // Create export
        document.getElementById('export').setAttribute('href', 'data:' + convertedData);
        document.getElementById('export').setAttribute('download','data.geojson');
    }

    var add = function(e) {
        const data = drawnItems.toGeoJSON();

        fetch('/make_raster', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify(data),
        })
        .then(response => response.json())
        .then(data => {
            console.log(data)
            merged_file_id = data.id;
            console.log('Success:', data);
        })
        .catch((error) => {
            console.error('Error:', error);
        });
    }

    var subtract = function(e) {
        const data = drawnItems.toGeoJSON();

        fetch('/subtract', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify(data),
        })
        .then(response => response.json())
        .then(data => {
            console.log(data)
            sub_file_id = data.id;
            console.log('Success:', data);
        })
        .catch((error) => {
            console.error('Error:', error);
        });
    }

    document.getElementById('add-down').addEventListener('click', (e) => {
        var fileName = merged_file_id
        fetch('/download?file='+fileName)
        .then(resp => resp.blob())
        .then(blob => {
            var file = window.URL.createObjectURL(blob);
            window.location.assign(file);
        })
        .catch(() => alert('oh no!'));
    })

    document.getElementById('sub-down').addEventListener('click', (e) => {
        var fileName = sub_file_id
        fetch('/download?file='+fileName)
        .then(resp => resp.blob())
        .then(blob => {
            var file = window.URL.createObjectURL(blob);
            window.location.assign(file);
        })
        .catch((e) => alert(e.message));
    })
    function view_tiff(){
        image_source = document.getElementById('image_source').value;
        image_file = document.getElementById('FileUnder').value;
        band1 = document.getElementById('band1').value;
        band2 = document.getElementById('band2').value;
        band3 = document.getElementById('band3').value;

	    if (orginal_image != undefined) {
	    	map.removeLayer(orginal_image)
	    }
         // layerControl.removeLayer(orginal_image)
        var index, markerToChange;
        for (index = 0; index < Object.keys(layerControl._layers).length; index++) {
                if ( Object.values(layerControl._layers)[index]['name']== 'Actual_image') {
                    markerToChange = Object.values(layerControl._layers)[index];
                    break;
                }
        }
        if (markerToChange != undefined) {
	    	layerControl.removeLayer(markerToChange.layer)
        }

        orginal_image = L.tileLayer.wms(bas_url+'view_image_sentinel_2?image_file=' + image_file + '&image_source=' + image_source+ '&band1='+ band1+ '&band2=' + band2+ '&band3=' + band3,
        {
	    	id: "orginal_image",
	    	data: 'ElectionGIS:ac',
	    	format: 'image/png',
	    	transparent: true,
	    	srs: 'EPSG:4326',
	    	zIndex: 100000000
	    });
	    // orginal_image.addTo(map)

        orginal_image.addTo(map)
        layerControl.addOverlay(orginal_image,"Actual_image")
    }

    function remove_input_layer() {
	    if (orginal_image != undefined) {
	    	map.removeLayer(orginal_image);
	    }
    }
</script>
</body>
</html>